/**
* File: War3Source_boar.sp
* Description: The Boar race for SourceCraft.
* Author(s): SenatoR
*/

#pragma semicolon 1
#include <sourcemod>
#include <sdktools>
#include <sdktools_stocks>
#include <sdktools_tempents>
#include <sdktools_functions>
#include <sdktools_tempents_stocks>
#include <sdktools_entinput>
#include <sdktools_sound>
#include <sdkhooks>

#include "W3SIncs/War3Source_Interface"

// War3Source stuff
new thisRaceID, SKILL_SPEEDHP, SKILL_DROP, SKILL_INFECT, SKILL_EVADE,ULT_STIM ;

new EvadeSprite;


new String:RaceModel[PLATFORM_MAX_PATH] = "models/player/vad36mutant_boar/boar_fix.mdl";
// Chance/Data Arrays
new Float:InfectChance[7] = { 0.0, 0.30, 0.40, 0.45, 0.50, 0.55, 0.60 };
new Float:FlameSpeed[5] = { 1.0, 1.05, 1.10, 1.15, 1.4 };
new Float:DropChance[5] = { 0.0, 0.20, 0.30, 0.40, 0.50 };
new FlameHP[5] = { 0, 100, 200, 300, 400 };
new Float:EvadeChance[6] = { 0.10, 0.25, 0.40, 0.50, 0.60, 0.70,};
new bool:Infected[64];
new InfectedBy[64];
new Float:StimAttackSpeed[6] = { 1.0, 1.1, 1.2, 1.4, 1.6, 1.8 };
new Float:StimSpeed[6] = { 1.0, 1.1, 1.2, 1.4, 1.6, 1.8 };


public Plugin:myinfo = 
{
	name = "War3Source Race - Boar",
	author = "SenatoR",
	description = "The Boar race for War3Source.",
	version = "BETA",
	url = ""
};

public OnPluginStart()
{
	LoadTranslations( "w3s.race.undead.phrases" );
}

public OnMapStart()
{
	EvadeSprite = PrecacheModel( "materials/sprites/yellowflare.vmt" );
	W3AddFile("models/player/vad36mutant_boar/boar_fix.mdl");
	W3AddFile("models/player/vad36mutant_boar/boar_fix.sw.vtx");
	W3AddFile("models/player/vad36mutant_boar/boar_fix.phy");
	W3AddFile("models/player/vad36mutant_boar/boar_fix.vvd");
	W3AddFile("models/player/vad36mutant_boar/boar_fix.dx80.vtx");
	W3AddFile("models/player/vad36mutant_boar/boar_fix.dx90.vtx");
		
	W3AddFile("materials/models/player/vad36mutant_boar/act_mutant_boar_u.vtf");
	W3AddFile("materials/models/player/vad36mutant_boar/act_mutant_boar.vmt");
	W3AddFile("materials/models/player/vad36mutant_boar/act_mutant_boar_fur.vmt");
	W3AddFile("materials/models/player/vad36mutant_boar/act_mutant_boar_n.vtf");
	W3AddModel(RaceModel);
}
public OnWar3PluginReady()
{
	thisRaceID = War3_CreateNewRace( "Кабан", "boar" );
	
	SKILL_SPEEDHP = War3_AddRaceSkill( thisRaceID, "Мутация", "Дополнительная скорость и жизни", false );	
	SKILL_DROP = War3_AddRaceSkill( thisRaceID, "Клыки", "Шанс выбить оружие 30%-60%.", false );
	SKILL_INFECT = War3_AddRaceSkill( thisRaceID, "Инфекция", "Заражаете противника", false, 6 );
	SKILL_EVADE = War3_AddRaceSkill( thisRaceID, "Скользкая кожа", "Вероятность рикошета пули", false );
	ULT_STIM = War3_AddRaceSkill( thisRaceID, "Ярость", "Увеличивает скорость и скорость атаки", true, 5 );
	W3SkillCooldownOnSpawn( thisRaceID, ULT_STIM, 20.0 );
	War3_CreateRaceEnd( thisRaceID );
}

public InitPassiveSkills( client )
{
	if( War3_GetRace( client ) == thisRaceID )
	{
		War3_SetBuff( client, fMaxSpeed, thisRaceID, FlameSpeed[War3_GetSkillLevel( client, thisRaceID, SKILL_SPEEDHP )] );
		War3_SetMaxHP_INTERNAL( client, FlameHP[War3_GetSkillLevel( client, thisRaceID, SKILL_SPEEDHP )] );
		if( War3_GetMaxHP( client ) > GetClientHealth( client ) )
		{
			War3_HealToMaxHP( client, ( War3_GetMaxHP( client ) - GetClientHealth( client ) ) );
		}
	}
}

public OnRaceChanged( client,oldrace,newrace )
{
	if( newrace != thisRaceID )
	{
		War3_WeaponRestrictTo( client, thisRaceID, "" );
		War3_SetBuff( client, fMaxSpeed, thisRaceID, 1.0 );
	}
	else
	{	
		War3_WeaponRestrictTo( client, thisRaceID, "weapon_knife" );
		if( IsPlayerAlive( client ) )
		{
			InitPassiveSkills( client );
		}
	}
}

public OnSkillLevelChanged( client, race, skill, newskilllevel )
{
	InitPassiveSkills( client );
}

public OnWar3EventSpawn( client )
{
	new race = War3_GetRace( client );
	if( race == thisRaceID )
	SetEntityModel(client, RaceModel);
	{
		InitPassiveSkills( client );
	}
}

public OnWar3EventPostHurt( victim, attacker, damage )
{
	if( W3GetDamageIsBullet() && ValidPlayer( victim, true ) && ValidPlayer( attacker, true ) && GetClientTeam( victim ) != GetClientTeam( attacker ) )
	{
		if( War3_GetRace( attacker ) == thisRaceID )
		{
			new skill_drop = War3_GetSkillLevel( attacker, thisRaceID, SKILL_DROP );
			if( !Hexed( attacker, false ) && GetRandomFloat( 0.0, 1.0 ) <= DropChance[skill_drop] )
			{
				if( !W3HasImmunity( victim, Immunity_Skills ) )
				{
					FakeClientCommand( victim, "drop" );
				}
			}
			
			new skill_level = War3_GetSkillLevel( attacker, thisRaceID, SKILL_INFECT );
			if( !Hexed( attacker, false ) && GetRandomFloat( 0.0, 1.0 ) <= InfectChance[skill_level] && !W3HasImmunity( victim, Immunity_Skills ) )
			{
				new String:NameAttacker[64];
				GetClientName( attacker, NameAttacker, 64 );
				
				new String:NameVictim[64];
				GetClientName( victim, NameVictim, 64 );
				
				if( !Infected[victim] )
				{
					PrintToChat( attacker, "\x05: \x03You have infected \x04%s!!", NameVictim );
					PrintToChat( victim, "\x05: \x03You have been \x05INFECTED \x03by \x04%s's \x03Infectious Bite!", NameAttacker );
				}
				
				Blood( victim );
				
				War3_DealDamage( victim, 5, attacker, DMG_BULLET, "infect" );
				
				Infected[victim] = true;
				InfectedBy[victim] = attacker;

			
			}
		}
	}
}


public Action:CalcInfect( Handle:timer, any:userid )
{
	for( new i = 1; i <= MaxClients; i++ )
	{
		if( ValidPlayer( i, true ) )
		{
			if( Infected[i] == true )
			{
				if( IsPlayerAlive( i ) && !W3HasImmunity( i, Immunity_Skills ) && ValidPlayer( InfectedBy[i], false ) )
				{
					War3_DealDamage( i, 5, InfectedBy[i], DMG_BULLET, "infect" );
				}
			}
		}
	}
}

stock Blood( client )
{
	new Float:Pos[3];
	GetClientAbsOrigin( client, Pos );
	new blood = CreateEntityByName( "env_blood" );
	if( blood )
	{
		DispatchKeyValue( blood, "color", "0" );
		DispatchKeyValue( blood, "amount", "50" );
		DispatchKeyValue( blood, "spawnflags", "109" );
		DispatchSpawn( blood );
		TeleportEntity( blood, Pos, NULL_VECTOR, NULL_VECTOR );
		AcceptEntityInput( blood, "emitblood" );
	}
}

public OnW3TakeDmgBullet( victim, attacker, Float:damage )
{
	if( IS_PLAYER( victim ) && IS_PLAYER( attacker ) && victim > 0 && attacker > 0 && attacker != victim )
	{
		new vteam = GetClientTeam( victim );
		new ateam = GetClientTeam( attacker );
		new race_victim = War3_GetRace( victim );
		if( vteam != ateam && race_victim == thisRaceID )
		{
			new skill_evade = War3_GetSkillLevel( victim, thisRaceID, SKILL_EVADE );
			if( skill_evade > 0 && !Hexed( victim, false ) && GetRandomFloat( 0.0, 1.0 ) <= EvadeChance[skill_evade] && !W3HasImmunity( attacker, Immunity_Skills ) ) 
			{
				War3_DamageModPercent( 0.0 );
				
				new Float:startpos[3];
				new Float:endpos[3];
				
				GetClientAbsOrigin( attacker, startpos );
				GetClientAbsOrigin( victim, endpos );
				
				TE_SetupBeamPoints( startpos, endpos, EvadeSprite, EvadeSprite, 0, 0, 1.0, 5.0, 5.0, 0, 0.0, { 255, 255, 255, 255 }, 0 );
				TE_SendToAll();
				
				W3FlashScreen( victim, RGBA_COLOR_BLUE );
				
				W3MsgEvaded( victim, attacker );
			}
		}
	}
}

public OnUltimateCommand( client, race, bool:pressed )
{
	if( race == thisRaceID && pressed && IsPlayerAlive( client ) && !Silenced( client ) )
	{
		new ult_level = War3_GetSkillLevel( client, race, ULT_STIM );
		if( ult_level > 0 )
		{
			if( War3_SkillNotInCooldown( client, thisRaceID, ULT_STIM, true ) )
			{
				War3_DealDamage( client, 0, client, DMG_BULLET, "boar_stim" );
				
				War3_SetBuff( client, fMaxSpeed, thisRaceID, StimSpeed[ult_level] );
				War3_SetBuff( client, fAttackSpeed, thisRaceID, StimAttackSpeed[ult_level] );
				
				CreateTimer( 10.0, StopStim, client );
				
				War3_CooldownMGR( client, 30.0, thisRaceID, ULT_STIM );
			}
		}
		else
		{
			W3MsgUltNotLeveled( client );
		}
	}
}

public Action:StopStim( Handle:timer, any:client )
{
	if( ValidPlayer( client, true ) )
	{
		War3_SetBuff( client, fMaxSpeed, thisRaceID, 1.0 );
		War3_SetBuff( client, fAttackSpeed, thisRaceID, 1.0 );
	}
}